// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/openclarity/kubeclarity/api/client/models"
)

// GetApplicationResourcesReader is a Reader for the GetApplicationResources structure.
type GetApplicationResourcesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetApplicationResourcesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetApplicationResourcesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewGetApplicationResourcesDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetApplicationResourcesOK creates a GetApplicationResourcesOK with default headers values
func NewGetApplicationResourcesOK() *GetApplicationResourcesOK {
	return &GetApplicationResourcesOK{}
}

/* GetApplicationResourcesOK describes a response with status code 200, with default header values.

Success
*/
type GetApplicationResourcesOK struct {
	Payload *GetApplicationResourcesOKBody
}

func (o *GetApplicationResourcesOK) Error() string {
	return fmt.Sprintf("[GET /applicationResources][%d] getApplicationResourcesOK  %+v", 200, o.Payload)
}
func (o *GetApplicationResourcesOK) GetPayload() *GetApplicationResourcesOKBody {
	return o.Payload
}

func (o *GetApplicationResourcesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(GetApplicationResourcesOKBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetApplicationResourcesDefault creates a GetApplicationResourcesDefault with default headers values
func NewGetApplicationResourcesDefault(code int) *GetApplicationResourcesDefault {
	return &GetApplicationResourcesDefault{
		_statusCode: code,
	}
}

/* GetApplicationResourcesDefault describes a response with status code -1, with default header values.

unknown error
*/
type GetApplicationResourcesDefault struct {
	_statusCode int

	Payload *models.APIResponse
}

// Code gets the status code for the get application resources default response
func (o *GetApplicationResourcesDefault) Code() int {
	return o._statusCode
}

func (o *GetApplicationResourcesDefault) Error() string {
	return fmt.Sprintf("[GET /applicationResources][%d] GetApplicationResources default  %+v", o._statusCode, o.Payload)
}
func (o *GetApplicationResourcesDefault) GetPayload() *models.APIResponse {
	return o.Payload
}

func (o *GetApplicationResourcesDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.APIResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetApplicationResourcesOKBody get application resources o k body
swagger:model GetApplicationResourcesOKBody
*/
type GetApplicationResourcesOKBody struct {

	// List of application resources in the given filters and page. List length must be lower or equal to pageSize
	Items []*models.ApplicationResource `json:"items"`

	// Total application resources count under the given filters
	// Required: true
	Total *int64 `json:"total"`
}

// Validate validates this get application resources o k body
func (o *GetApplicationResourcesOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateItems(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateTotal(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetApplicationResourcesOKBody) validateItems(formats strfmt.Registry) error {
	if swag.IsZero(o.Items) { // not required
		return nil
	}

	for i := 0; i < len(o.Items); i++ {
		if swag.IsZero(o.Items[i]) { // not required
			continue
		}

		if o.Items[i] != nil {
			if err := o.Items[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getApplicationResourcesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (o *GetApplicationResourcesOKBody) validateTotal(formats strfmt.Registry) error {

	if err := validate.Required("getApplicationResourcesOK"+"."+"total", "body", o.Total); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this get application resources o k body based on the context it is used
func (o *GetApplicationResourcesOKBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateItems(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetApplicationResourcesOKBody) contextValidateItems(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(o.Items); i++ {

		if o.Items[i] != nil {
			if err := o.Items[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getApplicationResourcesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetApplicationResourcesOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetApplicationResourcesOKBody) UnmarshalBinary(b []byte) error {
	var res GetApplicationResourcesOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
